//在队头进行删除，在队尾进行插入
//记住，front指的是空的地方
#include <stdio.h>
#include <malloc.h>
#define MAXSIZE 50
typedef int ElemType;
typedef struct
{
    ElemType data[MAXSIZE];
    int front, rear;
} SqQueue;

void InitQueue(SqQueue *&q)
{
    q = (SqQueue *)malloc(sizeof(SqQueue));
    q->front = q->rear = -1;
}

void DestoryQueue(SqQueue *&q)
{
    free(q);
}

bool QueueEmpty(SqQueue *q)
{
    return (q->front == q->rear);
}

bool enQueue(SqQueue *&q, ElemType e)
{
    if (q->rear == MAXSIZE - 1)
        return false;
    q->rear++;
    q->data[q->rear] = e;
    return true;
}

bool deQueue(SqQueue *&q, ElemType &e)
{
    if (q->front == q->rear)
        return false;
    q->front++;
    e = q->data[q->front];
    return true;
}

/****************************************************************************************/
//环形队列
void InitQueue(SqQueue *&q)
{
    q = (SqQueue *)malloc(sizeof(SqQueue));
    q->front = q->rear = 0; //不是-1了
}

bool enQueue(SqQueue *&q, ElemType e)
{
    if ((q->rear + 1) % MAXSIZE == q->front)
        return false;
    q->rear = (q->rear + 1) % MAXSIZE;
    q->data[q->rear] = e;
    return true;
}

bool dequeue(SqQueue *&q, ElemType e)
{
    if (q->front == q->rear)
        return false;
    q->front = (q->front + 1) % MAXSIZE;
    return true;
}

//这两个if判断条件挺有趣的

//队列非常有层次感，有很多妙用，既可以用于递归层次，又可以用于重复
//比如书上这个很强的1212报到1出列的问题
void number(int n)
{
    int i;
    ElemType e;
    SqQueue *q;
    for (int i = 0; i <= n; i++)
        enQueue(q, i);
    printf("报数出列顺序：\n");
    while (!QueueEmpty(q))
    {
        dequeue(q, e);
        printf("%d", e);
        if (!QueueEmpty(q))
        {
            dequeue(q, e);
            enQueue(q, e); //偶数惨遭重新排队哈哈
        }
        printf("\n");
        DestoryQueue(q);
    }
}
//还可以定制双端队列什么的，其实原理都差不多